// ListFilesCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "lines.h"
#include "ListFilesCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CListFilesCtrl

CListFilesCtrl::CListFilesCtrl()
{
	m_nTotalLines = m_nComments = 0;
}

CListFilesCtrl::~CListFilesCtrl()
{
}


BEGIN_MESSAGE_MAP(CListFilesCtrl, CListCtrl)
	//{{AFX_MSG_MAP(CListFilesCtrl)
	ON_WM_DROPFILES()
	ON_WM_KEYDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CListFilesCtrl message handlers

void CListFilesCtrl::OnDropFiles(HDROP hDropInfo) 
{
	// Initializes the mask
	CString strFilePatern;
	GetParent()->GetParent()->GetDlgItem(0x480)->GetWindowText( strFilePatern );
	m_mask.Set( strFilePatern );

	m_nTotalLines = m_nComments = 0;
	DeleteAllItems();

	int i = 0;
	TCHAR buffer[MAX_PATH];
	while (DragQueryFile(hDropInfo, i++, buffer, MAX_PATH))
		Add((LPCTSTR)buffer);
	
	CListCtrl::OnDropFiles(hDropInfo);
}

void CListFilesCtrl::Add(LPCTSTR lpszFileName)
{
	CString fileName(lpszFileName);

	// Do we have an directory?
	DWORD dwFlags = GetFileAttributes( lpszFileName );
	if ( ( dwFlags & FILE_ATTRIBUTE_DIRECTORY ) == FILE_ATTRIBUTE_DIRECTORY )
	{
		WIN32_FIND_DATA data = {0};
		fileName += "\\*.*";
		HANDLE h = FindFirstFile( fileName, &data );
		if ( h != INVALID_HANDLE_VALUE )
		{
			while ( FindNextFile( h, &data ) )
			{
				CString strFileName = data.cFileName;
				if ( strFileName != "" )
					if ( strFileName[0]!= '.' )
					{
						Add( CString( lpszFileName ) + "\\" + strFileName );
					}
			}
		}
	}
	else
	{
		if ( m_mask.Match( lpszFileName ) )
		{
			CString path;
			int i = fileName.ReverseFind(TCHAR('\\'));
			if (i>=0)
			{
				path = fileName.Left(i);
				fileName = fileName.Mid(i+1);
			}
			int nItem = InsertItem(GetItemCount(), fileName);
			int nLines = CountLines(lpszFileName);
			Inc(nLines);
			CString lines; lines.Format(_T("%i"),nLines);
			SetItemText(nItem,1,lines);
			SetItemText(nItem,2,path);
		}
	}
}

void CListFilesCtrl::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	if (nChar == VK_DELETE)
	{
		int i = -1;
		while ((i = GetNextItem(-1, LVNI_SELECTED))>=0)
			Sub(i);
	}
	
	CListCtrl::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CListFilesCtrl::Sub(int nItem)
{
	Inc(- CountLines(nItem));
	DeleteItem(nItem);
}

int CListFilesCtrl::CountLines(LPCTSTR lpszFileName )
{
	int result = 0;
	CStdioFile file;
	if (file.Open(lpszFileName, CFile::modeRead | CFile::typeText))
	{
		TCHAR buffer[1024];
		while (file.ReadString(buffer, 1024))
		{
			result++;
			CString strLine( buffer );
			if ( strLine == "" )
				m_nComments++;
			else
				if ( strLine[0] == '/' )
					m_nComments++;

		}
		file.Close();
	}
	return result;
}

int CListFilesCtrl::CountLines(int nItem)
{
	CString path(GetItemText(nItem,2));
	CString file(GetItemText(nItem,0));
	if (!path.IsEmpty())
		file = path + TCHAR('\\') + file;
	return CountLines((LPCTSTR)file);
}

void CListFilesCtrl::Inc(int nLines)
{
	m_nTotalLines += nLines;
	if (CWnd* pWnd = GetParent())
		if (pWnd = pWnd->GetDlgItem(IDC_EDIT_LINES))
		{
			CString lines; lines.Format(_T("%i, (%i excluding comments and empty lines)"),m_nTotalLines, m_nTotalLines - m_nComments);
			pWnd->SetWindowText(lines);
		}
}
