/************************************
  REVISION LOG ENTRY
  Revision By: Mike ( mike@exontrol.com )
  Revised on June 14, 2001
  Comments: MaskWord.h: interface for the CMaskWord class.

  This code may be used in compiled form in any way you desire. This
  file may not be redistributed modified or unmodified without the authors
  written consent.

 ************************************/

#if !defined(AFX_MASKWORD_H__6F311563_3B59_11D3_8F69_0080AD303A9A__INCLUDED_)
#define AFX_MASKWORD_H__6F311563_3B59_11D3_8F69_0080AD303A9A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <string>
using namespace std;

class CMaskWord : public string
{
	typedef enum _StateEnum {
		Undefined = -1,
		Begin = 0,
		Any = '*',
		One = '?',
		Char,
		Digit = '#',
		End = 255
	} _StateEnum;

public:
	CMaskWord();
	CMaskWord( LPCTSTR szMaskWord );
	virtual ~CMaskWord();

	virtual void Set( LPCTSTR pszMaskWords );
	virtual BOOL Match( LPCTSTR szMatchWord );
	static string ExtractFileName( LPCTSTR szFileName );

protected:
	//Operations
	virtual BOOL MatchWord( LPCTSTR szMatchWord );
	virtual BOOL GetFirstPattern( string& str );
	virtual BOOL GetNextPattern( string& str );
	static void MakeLower( string* pSource );
	//Attributes
	_StateEnum State( TCHAR c );
	_StateEnum m_nCurrentState;  //Used by the Match function
	_StateEnum m_nPreviousState; //Used by the Match function
	string m_strPatterns;
	int m_nPatternSearch;
};

#endif // !defined(AFX_MASKWORD_H__6F311563_3B59_11D3_8F69_0080AD303A9A__INCLUDED_)
